      PROGRAM WPAREX_MT80W
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C                                                                      !
C     Program WPAREX, version 2007.12.01.                              !
C                                                                      !
C                                                                      !
C     The program extracts tidal parameters for individual stations    !
C     from world wide synthetic gravity tide parameter file            !
C     "CSR3G.dat" or NAO99G.dat".                                      !
C                                                                      !
C     wparex.dat:   Formatted file on which the station coordinates    !
C                   have to be stored before the execution of program  !
C                   WPAREX.                                            !
C     mt80w.out :   output for program mt80w.                          !
C     predict.out:  output for program PREDICT.                        !
C     tsoft.out :   output for program TSOFT.                          !
C                                                                      !
C     Program creation:  1994.05.16 by Hans-Georg Wenzel,              !
C     Last modification at ICET: 2007.12.01 by Bernard Ducarme         !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      IMPLICIT DOUBLE PRECISION (D)
      DIMENSION DAMSY(10),DPHSY(10),N1(10),N2(10)
      DIMENSION DELT(15),PHAX(15),dlim1(15),dlim2(15)
      DIMENSION LIM1(15),LIM2(15),limc1(14),limc2(14),
     *limt1(15),limt2(15)
      CHARACTER*1 SN(2),EW(2),ASTER,SN1,EW1
      character*2 CWAVE(10)*2,charspec,star
      character*5 titoc(4)
      CHARACTER*6 ondf(15),ogr1
      CHARACTER CTEXT(8)*10
      character*9 direct
      CHARACTER*20 titet(15),CSTAT,filin,tit1,tit2,titmoc(4),titmod
      COMMON /ESYNTI/ DLATMIN,DLATMAX,DLONMIN,DLONMAX,dcov,FILIN,ctext
      DATA IUN12/2/,IUN16/7/
      DATA STAR/'*'/
      DATA CWAVE/'MF','Q1','O1','P1','K1','N2','M2','S2','K2','M3'/
      DATA ONDF/'M0S0','SSA','MF','Q1','O1','P1','K1','J1','OO1','N2',
     *'M2','S2','K2','M3','M4'/, direct/'modified/'/
      DATA SN/'N','S'/,EW/'E','W'/,ASTER/'*'/,dRC/1.D-10/,nwt/15/
      data titmoc/'csr3G.dat','nao99G.dat','tpxG.dat','meanG.dat'/
      data titoc/'CSR3','NAO99','TPX02','MEAN3'/,nmap/4/
      DATA LIMc1/1,2,20,129,194,242,252,275,297,334,399,442,448,489/
      DATA LIMc2/1,19,128,193,241,251,274,296,333,441,438,447,488,505/
      data limt1/1,2,35,282,425,531,548,587,627,732,881,976,992,1109,
     *1191/
      data limt2/1,34,281,424,530,547,586,626,731,880,975,991,1108,1190,
     *1200/,DDW/'W'/
      data titmod/'WAHR DEHANT'/,itam/4/,iind/0/
      data titet/'TEXTHEADER=','STATIONAME=','STATLATITU=','STATLONITU='
     *          ,'STATELEVAT=','STATGRAVIT=','STATAZIMUT=','TIDALCOMPO='
     *          ,'TIDALPOTEN=','AMTRUNCATE=','POLTIDECOR=','LODTIDECOR='
     *          ,'SAMPLERATE=','INITIALEPO=','PREDICSPAN='/
C
      OPEN(UNIT=IUN12,FILE='WPAREX.DAT',FORM='FORMATTED')
      OPEN(UNIT=IUN16,FILE='mt80w.out',FORM='FORMATTED')
      open(unit=13,file='eterna.ini',status='OLD')
      open(unit=9,file='predict.out',status='UNKNOWN')
      open(unit=8,file='tsoft.out',status='UNKNOWN')
c     initialisation
	dpi=datan(1.D0)*4.D0
	dcov=dpi/180.D0
      do 30 k=1,nwt
      read(13,8000)tit1,dlim1(k),dlim2(k),delt(k),phax(k),ogr1,tit2
      if(ogr1.ne.ondf(k))go to 91
   30 continue
      DAMSY(10)=1.0663d0
      DPHSY(10)=0.d0
      drho=datan(1.d0)/45.d0
C      WRITE(IUN16,17001)
      WRITE(*,17001)
c
c     CTE505 ou TAM1200
c
      write(6,1996)
 1996 format(1h ,'POTENTIAL: 1=CTE505, 2=tam1200')
      read(*,*)kpot
      if(kpot.eq.1)then
      nwt=nwt-1
      do 994 k=1,14
      lim1(k)=limc1(k)
      lim2(k)=limc2(k)
  994 continue
                   else
      do 995 k=1,15
      lim1(k)=limt1(k)
      lim2(k)=limt2(k)
  995 continue
                  end if
C
C     OUVERTURE FICHIERS DES EFFETS INDIRECTS
C
      write(*,'(a$)')' choice of map: 1=CSR3, 2=NAO99 '
      read(*,*)model
      filin=direct//titmoc(model)
      write(*,*)filin 
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Initialize storage array for tidal parameters:                   !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      IENT=1
      CALL WSYNTI(IENT,IUN16,DLAT,DLON,DAMSY,DPHSY,charspec)
      IENT=2
      Indi=0
      AZ=0.D0
      UN=1.D0
      IB=99
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Read stations latitude and longitude:                            !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 2005 READ(IUN12,17002,END=2100) NRST,CSTAT,DLAT,DLON,DH
      if(nrst.eq.9999)go to 2100
      dh1=dh/1000.d0
      DLONI=DLON
      IF(DLONI.GT.180.D0) DLONI=DLONI-360.D0
      dslat=dsin(dlat*drho)
      gTH=9.780327*(1.D0+(0.0053024*DSLAT*DSLAT))
      gTHB=gTH*100.0
c     MTW80
      WRITE(IUN16,1701) Indi,DLON,DLAT,DH1,gTHB,AZ,UN
 1701 Format(I2,6F10.4) 
      WRITE(IUN16,1702) 'STATION',NRST,CSTAT,'VERTICAL COMPONENT'
 1702 FORMAT(A7,2X,I10,2X,A10,4X,A18)
      WRITE(IUN16,1703) DLAT,'N',DLON,'E',DH,'M',gTH,'m/s**2'
 1703 FORMAT(F10.4,A1,F10.4,A1,F10.0,A1,F10.5,A6)
      write(iun16,7011)titmod,(CTEXT(I),I=1,5)
      write(iun16,7012)titoc(model)
 7011 format(' Earth model:',A12,5a10)
 7012 format(' Ocean model: ',A8)
      WRITE(IUN16,1704)
 1704 FORMAT(
     1' Program WPARICET: Interpolation of gravity tide parameters'/
     2' from 0.5 by 0.5 degree grid of Zahran and Zhou Jiangcun (2007).
     *')
c     format eterna
      SN1=SN(1)
      IF(DLAT.LT.0)SN1=SN(2)
      EW1=EW(1)
      IF(DLONI.LT.0)EW1=EW(2)
      ALA1=ABS(DLAT)
      ALO1=ABS(DLONI)
      write(9,8001)titet(1),nrst,cstat,titet(1),titmod,(CTEXT(k),k=1,5),
     *titet(1),ala1,sn1,alo1,ew1,dh,gthb,titet(1),titoc(model)
 8001 format(A11,'STATION ',I4,1x,A20/,A11,A12,5A10/,A11,F8.5,A2,5X,F9.5
     *,A1,5X,'H=',F5.0,'M',4X,'G=',F8.3/,A11,'OCEAN MODEL: ',A8)
      ge1=ge1/100.
      write(9,8002)titet(2),cstat,titet(3),dlat,titet(4),dloni,titet(5)
     *,alt,titet(6),gth,titet(7),az,titet(8),iind,titet(9),itam,
     *titet(10),drc
 8002 format(A11,A15/,A11,F9.5/,A11,F9.5/,A11,F6.0/,A11,F9.5/,A11,f6.0/,
     *A11,I5/,A11,I5/,A11,D7.1)
      write(9,8003)titet(11),az,titet(12),az,titet(13),titet(14),
     *titet(15)
 8003 format(2(A11,F6.0/),A11,16X,'#data sampling in seconds(integer)'/,
     *A11,' xxxx   xx   xx #initial epoch in year, month, day'/,A11,16X,
     *'#time span in hours(integer)'/)
c     Tsoft
      write(8,9001)nrst,cstat,dloni,dlat,dh
 9001 format('[LOCATION] ',I4/,'COMMENT: ',A20/,'COORD: '2F10.4/,
     *'HEIGHT: 'F6.0/)
      write(8,9002)ista,titmod,(CTEXT(k),k=1,3),titoc(model),az,gth
 9002 format('[TIDECOMP] ',I4/,'NAME: ',A12,3A10'OCEAN MODEL: ',A8/,
     *'TYPE: 1 '/,'AZIM: ',F6.0/,'GRAV: ',F9.5)
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Interpolate synthetic gravity tide parameter from grid:          !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      IENT=2
      CALL WSYNTI(IENT,IUN16,DLAT,DLONI,DAMSY,DPHSY,charspec)
      if(charspec.eq.star)then
      write(iun16,1707)
      write(*,1707)
 1707 format(' ATTENTION: station too close from a cell, interpolation '
     *,'is perhaps not very precise')
                          else
      write(*,1708)
 1708 format(' correct interpolation')      
                          end if
C      WRITE(IUN16,17003)
      WRITE(*,17003)
      WRITE(IUN16,1705)IB
 1705 FORMAT(I2)  
      WRITE(IUN16,1706)NRST
 1706 FORMAT(I4)
      do 2045 IW=1,5
      delt(iw+2)=damsy(iw)
      phax(iw+2)=dphsy(iw)
 2045 continue
      do 2046 iw=6,10
      delt(iw+4)=damsy(iw)
      phax(iw+4)=dphsy(iw)
 2046 continue
c
c     sortie des ondes
c
      write(9,8000)tit1,dlim1(1),dlim2(1),delt(1),phax(1),ondf(1),tit2
      write(8,9003)dlim1(1),dlim2(1),delt(1),phax(1),ondf(1)
      DO 50 I=2,NWT
      if(kpot.eq.1)then
      WRITE(iun16,5000)LIM1(I),LIM2(I),ONDF(I),DELT(I),PHAX(I)
 5000 FORMAT(I4,1H-,I3,2X,A4,18X,F8.5,8X,F9.4,F10.3)
                   else
      WRITE(iun16,5002)LIM1(I),LIM2(I),ONDF(I),DELT(I),PHAX(I)
 5002 FORMAT(I4,1H-,I4,2X,A6,15X,F8.5,8X,F9.4)
                   end if
      write(9,8000)tit1,dlim1(i),dlim2(i),delt(i),phax(i),ondf(i),tit2
 8000 format(A11,2f10.6,f10.5,f10.4,1X,A4,2x,A13)
      write(8,9003)dlim1(i),dlim2(i),delt(i),phax(i),ondf(i)
 9003 format('COMP:',2F10.6,F10.5,F9.4,1x,A4)
   50 continue      
C     
      DO 2050 IW=1,10
      WRITE(*,17004)    NRST,CSTAT,CWAVE(IW),DLAT,DLON,DAMSY(IW),
     1 DPHSY(IW)
 2050 CONTINUE
      GOTO 2005    
 2100 CONTINUE
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Format statements:                                               !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
17001 FORMAT(/
     1' Program WPARicet. Interpolation of gravity tide parameters'/
     2' from 1 by 1 degree grid of Zahran and Zhou Jiangcun.'/)
17002 FORMAT(I4,A21,F8.4,F9.4,F4.0)
17003 FORMAT(//'               Station wave  latitude longitude',
     1'  ampl.fact.   phase lead'/) 
17004 FORMAT(1X,I10,1X,A10,3X,A2,2F10.4,F12.4,F12.2)
   91 stop
      END
C
      SUBROUTINE WSYNTI(IENT,IUN16,DLAT,DLON,DAMSY,DPHSY,charspec)
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C                                                                      !
C     Routine WSYNTI, version 2007.12.01.                              !
C                                                                      !
C     With IENT=1, the routine reads the synthetic gravity tide        !
C                  parameters for and stores them in RAM.              !
C     With IENT=2, the routine interpolates by bilinear interpolation  !
C                  the synthetic gravity tide parameters DAMSYN, DPHSY !
C                  at given station coordinates DLAT, DLON.            !
C                                                                      !
C     Routine creation:  1994.05.16 by Hans-Georg Wenzel,              !
C                        e-mail: wenzel@gik.bau-verm.uni-karlsruhe.de  !
C     Last modification: 2007.12.01 by Bernard Ducarme                 !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      IMPLICIT DOUBLE PRECISION (D)
      DIMENSION DAMSY(10),DPHSY(10),drtt(4),damyc(10),damys(10),
     *dampc(10,4),damps(10,4)
      real*8 ampl(10,4),phas(10,4),flat(4),flon(4)
      DIMENSION DAMSIN(10),DPHSIN(10)
      PARAMETER (ILATMA=360,ILONMA=720)
      DIMENSION DAMSYN(10,ILATMA,ILONMA),DPHSYN(10,ILATMA,ILONMA)
      COMMON /ESYNTI/ DLATMIN,DLATMAX,DLONMIN,DLONMAX,dcov,FILIN,ctext
      CHARACTER CTEXT(8)*10,CENDT*10,filin*20,treli*2,charspec*2
      character*2 problem(ilatma,ilonma),star,bl
      DATA CENDT/'C*********'/,star/'*'/,bl/' '/
      DATA IUN1/1/,DDLAT/-0.5D0/,DDLON/0.5D0/
      DATA NOUT/0/
      IF(IENT.NE.1) GOTO 2000
      OPEN(UNIT=IUN1,FILE=filin,FORM='FORMATTED')
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Define grid area:                                                !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      DLATMAX=  89.75D0
      DLATMIN= -89.75D0
      DLONMIN= -179.75D0
      DLONMAX=  179.75D0
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Fill grid with dummys:                                           !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      NLAT=DLATMAX-DLATMIN+1.1
      NLAT=NLAT*2
      NLON=DLONMAX-DLONMIN+1.1
      NLON=NLON*2
      DO 1100 ILAT=1,NLAT
      DO 1100 ILON=1,NLON
      DO 1100 IW=1,10
      DAMSYN(IW,ILAT,ILON)=999.999D0
 1100 DPHSYN(IW,ILAT,ILON)=999.999D0 
      NSTO=0
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Read grid of synthetic tidal parameters:                         !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 1200 READ(IUN1,17001)   (CTEXT(I),I=1,8) 
c      WRITE(IUN16,17002) (CTEXT(I),I=1,8)
      WRITE(*,17002)     (CTEXT(I),I=1,8)
c      IF(CTEXT(1).NE.CENDT) GOTO 1200
 1210 CONTINUE
      READ(IUN1,17003,END=3000) DLON,DLAT,RH,NUM,TRELI
      IF(DLAT.LT.DLATMIN) GOTO 3000
      ILAT=(DLATMAX-DLAT)*2.d0+1.1
      IF(DLON.GT.180.D0) DLON=DLON-360.D0
      ILON=(DLON-DLONMIN)*2.d0+1.1
      problem(ilat,ilon)=treli
      IF(ILON.LT.0) ILON=ILON-1
      READ(IUN1,17004) (DAMSIN(IW),IW=1,9)
      READ(IUN1,17004) (DPHSIN(IW),IW=1,9)
      IF(ILAT.LT.1)      GOTO 1210
      IF(ILAT.GT.ILATMA) GOTO 1210
      IF(ILON.LT.1)      GOTO 1210
      IF(ILON.GT.ILONMA) GOTO 1210
      DO 1220 IW=1,9
      DAMSYN(IW,ILAT,ILON)=DAMSIN(IW)
      DPHSYN(IW,ILAT,ILON)=DPHSIN(IW)
 1220 CONTINUE
      NSTO=NSTO+1     
      GOTO 1210
 2000 CONTINUE
      CLOSE (IUN1)
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     IENT=2: Interpolate gravity tide parameter.                      !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      DLONR=DLON
      IF(DLONR.GT.180.D0) DLONR=DLONR-360.D0
      ILAT=(DLATMAX-DLAT)*2.d0 +1.01
      ILON=(DLONR-DLONMIN)*2.d0+1.01
*      write(*,*)dlat,ilat,dlonr,ilon
      DO 2010 IW=1,9
      DAMSY(IW)=999.999D0
      DPHSY(IW)=999.999D0
      do 2010 k=1,4
      ampl(iw,k)=999.999d0
      phas(iw,k)=999.999d0
      drtt(k)=0.
 2010 CONTINUE
      DLAT1=DLATMAX-DBLE(ILAT-1)/2.d0
      DLON1=DLONMIN+DBLE(ILON-1)/2.d0
      DLAT2=DLAT1+DDLAT
      DLON2=DLON1+DDLON
*      write(*,*)dlat1,dlat2,dlon1,dlon2
      IUNDEF=0
      DO 2020 IW=1,9
      IF(DAMSYN(IW,ILAT,ILON).GT.999.D0) THEN
         if(iw.eq.1)then
         NOUT=1
         IF(DLON1.LT.0.D0) DLON1=DLON1+360.D0
         WRITE(IUN16,17101) NOUT,DLAT1,DLON1
         IUNDEF=IUNDEF+1
                   end if
                                         ELSE
      ampl(iw,1)=damsyn(iw,ilat,ilon)
      phas(iw,1)=dphsyn(iw,ilat,ilon)
      dphrad=phas(iw,1)*dcov
      dampc(iw,1)=ampl(iw,1)*dcos(dphrad)
      damps(iw,1)=ampl(iw,1)*dsin(dphrad)
      flat(1)=dlat1
      flon(1)=dlon1
                                         END IF
      IF(DAMSYN(IW,ILAT+1,ILON).GT.999.D0) THEN
         if(iw.eq.1)then
         NOUT=2
         IF(DLON1.LT.0.D0) DLON1=DLON1+360.D0
         WRITE(IUN16,17101) NOUT,DLAT2,DLON1
         IUNDEF=IUNDEF+1
                    end if
                                           ELSE
      ampl(iw,2)=damsyn(iw,ilat+1,ilon)
      phas(iw,2)=dphsyn(iw,ilat+1,ilon)
      dphrad=phas(iw,2)*dcov
      dampc(iw,2)=ampl(iw,2)*dcos(dphrad)
      damps(iw,2)=ampl(iw,2)*dsin(dphrad)
      flat(2)=dlat2
      flon(2)=dlon1
                                           END IF
      IF(DAMSYN(IW,ILAT,ILON+1).GT.999.D0) THEN
         if(iw.eq.1)then
         NOUT=3
         IF(DLON2.LT.0.D0) DLON2=DLON2+360.D0
         WRITE(IUN16,17101) NOUT,DLAT1,DLON2
         IUNDEF=IUNDEF+1
                    end if
                                           ELSE
      ampl(iw,3)=damsyn(iw,ilat,ilon+1)
      phas(iw,3)=dphsyn(iw,ilat,ilon+1)
      dphrad=phas(iw,3)*dcov
      dampc(iw,3)=ampl(iw,3)*dcos(dphrad)
      damps(iw,3)=ampl(iw,3)*dsin(dphrad)
      flat(3)=dlat1
      flon(3)=dlon2
                                           END IF
      IF(DAMSYN(IW,ILAT+1,ILON+1).GT.999.D0) THEN
         if(iw.eq.1)then
         NOUT=4
         IF(DLON2.LT.0.D0) DLON2=DLON2+360.D0
         WRITE(IUN16,17101) NOUT,DLAT2,DLON2
         IUNDEF=IUNDEF+1
         end if
                                             ELSE
      ampl(iw,4)=damsyn(iw,ilat+1,ilon+1)
      phas(iw,4)=dphsyn(iw,ilat+1,ilon+1)
      dphrad=phas(iw,4)*dcov
      dampc(iw,4)=ampl(iw,4)*dcos(dphrad)
      damps(iw,4)=ampl(iw,4)*dsin(dphrad)
      flat(4)=dlat2
      flon(4)=dlon2
                                            END IF
      IF(IUNDEF.EQ.0) GOTO 2200
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Grid point is undefined.                                         !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
17101 FORMAT(I10,2F10.4,'UNDEFINED')
      idef=4-iundef
      if(idef.gt.0.and.iw.eq.1)THEN
      dclose=0.d0
      do 2201, k=1,4
      if(ampl(iw,k).lt.999.d0)then
      write(iun16,17102)idef,flat(k),flon(k),ampl(iw,k),phas(iw,k)
17102 format(I5,' defined point',2f10.2,f10.4,f10.2)
      dCRTG=DCOS(flat(k)*dcov)
      dSRTG=DSIN(flat(k)*dcov)
      dCRTS=dcos(dlat*dcov)
      dSRTS=dsin(dlat*dcov)
      dRTT(k)=dCRTG*dCRTS+dSRTG*dSRTS*DCOS((flon(k)-dlonr)*dcov)
      if(drtt(k).gt.dclose)then
      dclose=drtt(k)
      nclose=k
                           end if
                              end if
 2201 continue
      dRTG=DACOS(dclose)/dcov
      write(iun16,17103)nclose,flat(nclose),flon(nclose),drtg
17103 format('CLOSEST POINT',I2,3F8.2,''/5F12.8)
                              END IF
      if(idef.gt.0)then
      DAMSY(IW)=ampl(iw,nclose) 
      DPHSY(IW)=phas(iw,nclose)
c      write(iun16,*)damsy(iw),dphsy(iw)
      go to 2020
                   else
      RETURN
                   end if     

 2200 CONTINUE
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Compute values by bilinear interpolation:                        !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*      write(7,*)DAMSYN(IW,ILAT,ILON),DAMSYN(IW,ILAT,ILON+1),
*     *DAMSYN(IW,ILAT+1,ILON),DAMSYN(IW,ILAT+1,ILON+1)
      DI = (DLAT-DLAT1)/DDLAT
      DJ = (DLONR-DLON1)/DDLON
      DIM1 = 1.D0-DI
      DJM1 = 1.D0-DJ
      DAMYC(IW)=DIM1*DJM1*DAMpc(IW,1)
     1     + DJ*DIM1*DAMpc(IW,3)
     2     + DI*DJM1*DAMpc(IW,2)
     3     + DI*DJ*DAMpc(IW,4)
      DAMYS(IW)=DIM1*DJM1*DAMps(IW,1)
     1     + DJ*DIM1*DAMps(IW,3)
     2     + DI*DJM1*DAMps(IW,2)
     3     + DI*DJ*DAMps(IW,4)
      DAMSY(IW)=dsqrt(DAMYC(IW)*DAMYC(IW)+DAMYS(IW)*DAMYS(IW))
      DPHSY(IW)=DATAN(DAMYS(IW)/DAMYC(IW))/DCOV
c      DAMSY(IW)=DIM1*DJM1*DAMSYN(IW,ILAT,ILON)
c     1     + DJ*DIM1*DAMSYN(IW,ILAT,ILON+1)
c     2     + DI*DJM1*DAMSYN(IW,ILAT+1,ILON)
c     3     + DI*DJ*DAMSYN(IW,ILAT+1,ILON+1)
c      DPHSY(IW)=DIM1*DJM1*DPHSYN(IW,ILAT,ILON)
c     1     + DJ*DIM1*DPHSYN(IW,ILAT,ILON+1)
c     2     + DI*DJM1*DPHSYN(IW,ILAT+1,ILON)
c     3     + DI*DJ*DPHSYN(IW,ILAT+1,ILON+1)
 2020 CONTINUE
      charspec=bl
      if(problem(ilat,ilon).eq.star.or.problem(ilat,ilon+1).eq.star)then
      charspec=star
                                                                    else
      if(problem(ilat+1,ilon).eq.star.or.problem(ilat+1,ilon+1).eq.star)
     *charspec=star
                                                                   endif
 3000 CLOSE(IUN1)
      write(*,*)nsto
      RETURN
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Format statements:                                               !
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
17001 FORMAT(8A10)
17002 FORMAT(1X,7A10,A8)
17003 FORMAT(3F10.2,I10,1x,A1)
17004 FORMAT(9f10.4)
      END
